clear();
//Implementierung eines modifizierten
//Gradientenverfahrens mit Scilab für 
//die Fehlerfunktion f(x,y)=x^3-4x+y^3-16y

//1. Schritt: Fehlerfunktion formulieren

function z = berechneFehler(x,y)
    z = x^3-4*x+y^3-16*y;
endfunction

//2. Schritt: Startwert festlegen:
// (hier beginnt "unsere Skifahrt")

x_alt = 0;
y_alt = 0;

//3. Implementierung des iterativen Verfahrens

aktueller_fehler = berechneFehler(x_alt,y_alt);

alfa = 0.01; //Gewichtung der Änderung.

//Zielwert: xsoll = 1.154700538,  ysol = 2.309401077

for i=1:1000  //innere Befehle iterativ ausführen
    dx = 2*floor(grand(1, 1, "unf", 0, 1.999999999)) - 1;  //liefert -1 oder +1 zufällig
    dy = 2*floor(grand(1, 1, "unf", 0, 1.999999999)) - 1;  //liefert -1 oder +1 zufällig

    x_neu = x_alt + alfa*dx;
    y_neu = y_alt + alfa*dy;

    neuer_fehler = berechneFehler(x_neu,y_neu);

//Prüfen, ob neuer Fehler kleiner, wenn ja, zu neuem Punkt gehen, sonst bei altem bleiben    
    if neuer_fehler<=aktueller_fehler then
        x_alt = x_neu;
        y_alt = y_neu;
        aktueller_fehler = neuer_fehler;
        disp('fehler='+string(aktueller_fehler));     
        disp('x='+string(x_alt));     
        disp('y='+string(y_alt));     
    end
end